%m_beispiel_10_2_3_m.m
%Optimierung im Zeitbereich
%ITAE-, ISTAE-Kriterium, Anstiegsfunktion

clc, clear, clf

tmax = 90.0; xmax = 1.2; xmin = -xmax;  
%Regelstrecke
KIS = 0.25; TS = 1;

%ITAE-Kriterium, n = 3
f1 = 2.7647; f2 = 1.3916;
KR_ITAE = f1 / (KIS * f2^2 * TS)
TN_ITAE = f1 * f2 * TS
omk_ITAE = 1.0 / (f2 * TS)

%ISTAE-Kriterium, n = 3
f1 = 2.3983; f2 = 1.8229;
KR_ISTAE = f1 / (KIS * f2^2 * TS)
TN_ISTAE = f1 * f2 * TS
omk_ISTAE = 1.0 / (f2 * TS)

sim('m_beispiel_10_2_3')

hold off
lw = 1.5;
subplot(311)
plot (x.time, x.signals.values(:,1),'k-', 'LineWidth', lw)
grid on, hold on,
plot (x.time, x.signals.values(:,3),'k--' , 'LineWidth', lw)
title ('Optimierung ITAE-Kriterium, Regelgre x(t), Fhrungsgre w(t)')
xlabel('Zeit t / s'), ylabel('x(t), w(t)'), axis([0 tmax xmin xmax]),
h = legend (' x(t)',' w(t)');

hold off
subplot (312)
plot (x.time, x.signals.values(:,2),'k-', 'LineWidth', lw)
grid on, hold on,
plot (x.time, x.signals.values(:,3),'k--', 'LineWidth', lw)
title ('Optimierung ISTAE-Kriterium, Regelgre x(t), Fhrungsgre w(t)')
xlabel('Zeit t / s'), ylabel('x(t), w(t)'), axis([0 tmax xmin xmax]),
h = legend (' x(t)',' w(t)');
hold off

subplot (313)
plot (x.time, x.signals.values(:,3)-x.signals.values(:,1),'k-', 'LineWidth', lw)
grid on, hold on,
plot (x.time, x.signals.values(:,3)-x.signals.values(:,2),'k--', 'LineWidth', lw)
title ('Optimierung ITAE-, ISTAE-Kriterium, Regeldifferenz x_d(t)')
xlabel('Zeit t / s'), ylabel('x_d(t)'), axis([0 tmax -0.35  0.35]),
h = legend (' x_d(t), ITAE',' x_d(t), ISTAE');
hold off

%{
Ergebnisse
KR_ITAE =   5.710566110910112
TN_ITAE =   3.847356520000000
omk_ITAE =  0.718597298074159

KR_ISTAE =  2.886940338912628
TN_ISTAE =  4.371861070000000
omk_ISTAE = 0.548576444127489
%}