%Optimierung im Zeitbereich, Minimum-Berechnung
%Zeitgewichtete Betragsregelflche ITAE
%optimierung_ITAE_parabel.m
%Eingangsgre Parabelfunktion

clear, clf, clc, format long

delta_t = 0.0001; tmax = 150.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = 0:delta_t:tmax; w = (t .* t / 2.0)';
dfa = 1.0e-4; df_min = 0.75e-4; nmax = 8;

berechne = 1; n = 3; %Ergebnisse
A_ITAE =   2.375266927732409; f1m =  2.3635; f2m =  1.8823;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        G_ITAE_p(n) = tf([f2 f1 1], [1 f2 f1 1]);
        x = lsim(G_ITAE_p(n), w, t);
        A = delta_t * trapz(t' .* abs(w - x));
        if A_min > A + eps
           A_min = A; anz_min = anz_min + 1; f1_min = f1; f2_min = f2;
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, f1m = f1_min, f2m = f2_min,
end
df = df / 2.0;
end
G_ITAE_p(n) = tf([f2m f1m 1], [1 f2m f1m 1]);

berechne = 0; n = 4; %Ergebnisse
A_ITAE =  5.046109595318614;
f1m =  2.4948; f2m =  3.5583; f3m =  1.6002;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1;
while anz_min > 0 
    anz_min = 0; j = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df
            G_ITAE_p(n) = tf ([f2 f1 1], [1 f3 f2 f1 1]);
            x = lsim(G_ITAE_p(n), w,t);
            A = delta_t * trapz(t' .* abs(w - x));
            if A_min > A + eps
               A_min = A; anz_min = anz_min + 1; 
               f1_min = f1; f2_min = f2; f3_min = f3;
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, 
end
df = df / 2.0;
end
G_ITAE_p(n) = tf ([f2m f1m 1], [1 f3m f2m f1m 1]);

berechne = 0; n = 5; %Ergebnisse
A_ITAE =  14.183622617627861;
f1m =  3.3880; f2m =  4.6079; f3m =  4.5983; f4m =  2.0185;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                G_ITAE_p(n) = tf ([f2 f1 1], [1 f4 f3 f2 f1 1]);
                x = lsim(G_ITAE_p(n), w, t);
                A = delta_t * trapz(t' .* abs(w - x));
                if A_min > A
                   A_min = A; anz_min = anz_min + 1;
                   f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_ITAE_p(n) = tf ([f2m f1m 1], [1 f4m f3m f2m f1m 1]);

berechne = 0; n = 6; %Ergebnisse
A_ITAE =  24.022778886418127; f1m =  3.5861; f2m =  7.1153; 
f3m =  6.4108; f4m =  5.7616; f5m =  1.8338;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                for f5 = f5m-df:df:f5m+df
                    G_ITAE_p(n) = tf ([f2 f1 1], [1 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ITAE_p(n), w,t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5;
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, 
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min 
end
df = df / 2.0;
end
G_ITAE_p(n) = tf ([f2m f1m 1], [1 f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 7; %Ergebnisse
A_ITAE =  45.419342324955139; f1m =  4.4195; f2m =  8.5729;
f3m = 11.7602; f4m =  9.1448; f5m =  6.8001; f6m =  2.1468;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
     for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    G_ITAE_p(n) = tf ([f2 f1 1], [1 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ITAE_p(n), w,t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min 
end
df = df / 2.0;
end
G_ITAE_p(n) = tf ([f2m f1m 1], [1 f6m f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 8; %Ergebnisse
A_ITAE =  69.328796393606638;
f1m =  4.7411; f2m = 11.7796; f3m = 15.6408;
f4m = 18.1139; f5m = 11.0410; f6m =  7.9540; f7m =  1.9940;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    for f7 = f7m-df:df:f7m+df
                    G_ITAE_p(n) = tf ([f2 f1 1], [1 f7 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ITAE_p(n), w,t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5; f6_min = f6; f7_min = f7;
                    end
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min 
end
df = df / 2.0;
end
G_ITAE_p(n) = tf ([f2m f1m 1], [1 f7m f6m f5m f4m f3m f2m f1m 1]);

t = 0:10.0*delta_t:7.0; w = (t .* t / 2.0)';
subplot(121)
hold off
for n = 3:nmax
        x = lsim(G_ITAE_p(n), w, t);
        plot(t, x), hold on, grid on
end
plot(t, w, 'k:')
title('ITAE-Optimierung des Beschleunigungsfehlers')
xlabel('Zeit t / s'), ylabel('Parabelantwort x(t)')
axis ([0 7 -0.55 25])

subplot (122)
hold off
for n = 3:nmax
        x = lsim(G_ITAE_p(n), w, t);
        plot(t, (w - x)), hold on, grid on
end
title('fr w(t) = t^2/2, \omega_k = 1 s^-^1')
xlabel('Zeit t / s'), ylabel('Regeldifferenz x_d(t) = w(t) - x(t)')
axis ([0 7 -0.1 5])

